#include "../include/list.h"


/** Remove n-th element from linked list */
struct ListNode *removeNthElement(struct ListNode *head, int n) {
    int i=0;
    if (n < 0) {
        return head;
    }
    if (n == 0) {
        return head->next;
    }
    struct ListNode *current = head;
    while (i < n - 1 && current != NULL) {
        current = current->next;
        i++;
    }
    if (current != NULL && current->next != NULL && current->next->next != NULL) {
        struct ListNode *to_remove = current->next;
        current->next = current->next->next;
        free(to_remove);
    } else if (current != NULL && current->next != NULL) {
        free(current->next);
        current->next = NULL;
    }
    return head;
}

/** Length of a linked list */
unsigned int list_length(struct ListNode *head) {
    unsigned int length = 0;
    struct ListNode *current = head;
    while (current != NULL) {
        current = current->next;
        length++;
    }
    return length;
}

struct ListNode *removeNthFromEnd(struct ListNode *head, int n) {
    if (n < 0) {
        return head;
    }
    unsigned int length = list_length(head);
    return removeNthElement(head, length - n);
}


void test_1() {
    struct ListNode *l = NULL;
    l = list_insert(l, 1);
    l = list_insert(l, 2);
    l = list_insert(l, 3);
    l = list_insert(l, 4);
    l = list_insert(l, 5);
    struct ListNode *result_list = removeNthFromEnd(l, 2);
    list_print(result_list);
    list_clear(result_list);
}

void test_2() {
    struct ListNode *l = NULL;
    l = list_insert(l, 1);
    struct ListNode *result_list = removeNthFromEnd(l, 1);
    list_print(result_list);
    list_clear(result_list);
}

void test_3() {
    struct ListNode *l = NULL;
    l = list_insert(l, 1);
    l = list_insert(l, 2);
    struct ListNode *result_list = removeNthFromEnd(l, 1);
    list_print(result_list);
    list_clear(result_list);
}

int main() {
    test_1();
    test_2();
    test_3();
}
