int removeElement(int* nums, int numsSize, int val) {
    int right = 0;
    int left = numsSize - 1;
    int newSize = 0;
    while (right <= left) {
        if (nums[right] == val) {
            nums[right] = nums[left];
            left--;
        } else {
            newSize++;
            right++;
        }
    }
    return newSize;
}

#include <assert.h>
#include <stdlib.h>
#include <stdio.h>

int comp(const void *element1, const void *element2) {
    int f = *((int *) element1);
    int s = *((int *) element2);
    if (f > s) return 1;
    if (f < s) return -1;
    return 0;
}

void test_1() {
    int nums[] = {3,2,2,3};
    int val = 3;
    int k = removeElement(nums, 4, val);
    int expectedNums[] = {2,2};
    int expectedSize = 2;
    assert(k == expectedSize);
    qsort(nums, k, sizeof(int), comp);
    for (int i=0; i < k; i++) {
        assert(nums[i] == expectedNums[i]);
    }
}

void test_2() {
    int nums[] = {0,1,2,2,3,0,4,2};
    int val = 2;
    int k = removeElement(nums, 8, val);
    int expectedNums[] = {0,0,1,3,4};
    int expectedSize = 5;
    assert(k == expectedSize);
    qsort(nums, k, sizeof(int), comp);
    for (int i=0; i < k; i++) {
        assert(nums[i] == expectedNums[i]);
    }
}

int main() {
    test_1();
    test_2();
}
